﻿SERVERHOP_VERSION = 1.1

-- GUI
HOPADDON_WIDTH = 240
local HOPADDON_HEIGHT = 130
local HOPADDON_HEIGHTOPTIONS = 100

-- function globals
local MAX_RESULTS = 100

local QUEUE_INTERVAL = 3


-- Hop Search Declarations
local firstTime = true

local BlackList = {} -- list of pairs {realm name = time last visited}
local HopList= {} -- sorted list of groups available for server hopping
local lastUpdate = 0 -- update timer
local queue = false -- should addon queue for groups
local hopSearch = false -- should addon queue hopSearch
local autoAccept = false -- auto accept invites when you're invited during server hopping
local blacklistLength = 900 -- for how much seconds realm should be ignored

local backSearch = false -- start searching for a last server you've hopped on
local lastServer = nil -- last server you've hopped to


--[[ Activities
1-задания
4-арены   					no
2-подземелья
7-стычки					no
8-поле боя					no
3-рейды
9-рейтинговые поля боя		no
10-ашран					no
6-другое					no
]]

-- Your mom lies below

hopAddon = CreateFrame("Frame",nil,UIParent)
hopAddon:SetPoint("CENTER",0,0)
hopAddon:SetFrameStrata("HIGH")
hopAddon:SetWidth(HOPADDON_WIDTH) -- Set these to whatever height/width is needed 
hopAddon:SetHeight(HOPADDON_HEIGHT) -- for your Texture
hopAddon:SetBackdrop({bgFile = "Interface\\FrameGeneral\\UI-Background-Rock", 
					edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border", 
					tile = true, tileSize = 200, edgeSize = 24, 
					insets = { left = 4, right = 4, top = 4, bottom = 4 }});
hopAddon:SetBackdropColor(1,1,1,1);
hopAddon:Hide()

hopAddon.AddonRequest = false -- determines if search was requested by ServerHop


hopAddon.closeButton = CreateFrame("Button", nil, hopAddon,"UIPanelCloseButton")
hopAddon.closeButton:SetSize(25,25)
hopAddon.closeButton:SetPoint("BOTTOMRIGHT",-4,100)
hopAddon.closeButton:SetScript("OnClick", function(btn)
	hopAddon:Hide()
end)

hopAddon.buttonOptions = CreateFrame("Button",nil,hopAddon)
hopAddon.buttonOptions:SetSize(25,25)
hopAddon.buttonOptions:SetPoint("TOPLEFT",hopAddon,"TOPLEFT",0,0)
hopAddon.buttonOptions.icon = hopAddon.buttonOptions:CreateTexture(nil,"OVERLAY")
hopAddon.buttonOptions.icon:SetSize(25,25)
hopAddon.buttonOptions.icon:SetPoint("CENTER",0,0)
hopAddon.buttonOptions.icon:SetTexture("Interface\\PetBattles\\PetIcon-Mechanical")
hopAddon.buttonOptions.icon:SetTexCoord(0.79687500,0.49218750,0.50390625,0.65625000)

-- mode change
hopAddon.buttonChangeMode	= CreateFrame("Button",nil,hopAddon,"UIGoldBorderButtonTemplate")
hopAddon.buttonChangeMode:SetSize(140,24)
hopAddon.buttonChangeMode:SetPoint("BOTTOM", 0,110)
hopAddon.buttonChangeMode:SetText(HOPADDON_CHANGEMODE)


-- search GUI
hopAddon.searchFrame = CreateFrame("Frame",nil,hopAddon)
hopAddon.searchFrame:SetSize(HOPADDON_WIDTH,HOPADDON_HEIGHT)
hopAddon.searchFrame:SetPoint("BOTTOM",0,0)
-- Custom Search Declarations
hopAddon.searchFrame.lastUpdate = 0
hopAddon.searchFrame.FrameList = {} -- list of all search result frames
hopAddon.searchFrame.SearchString = "" -- last string used for search
local SearchKeywords = {} -- contains all keywords that user entered to filter search results
local CustomSearchList = {} -- contains all groups that match custom search
local CustomSearchBlacklist = {} --  {{name1 = time created},{name2 = time created},{name3 = time created}}
local customSearch = false -- should addon queue custom search


hopAddon.searchFrame.background = hopAddon.searchFrame:CreateTexture(nil,"BORDER")
hopAddon.searchFrame.background:SetSize(HOPADDON_WIDTH+106,HOPADDON_HEIGHT-10)
hopAddon.searchFrame.background:SetPoint("BOTTOM",1,5)
hopAddon.searchFrame.background:SetTexture("Interface\\Challenges\\challenges-besttime-bg")

hopAddon.searchFrame.stringSearching = hopAddon.searchFrame:CreateFontString("searchstatus", "OVERLAY", "QuestFont_Shadow_Huge")
hopAddon.searchFrame.stringSearching:SetPoint("BOTTOM",0,HOPADDON_HEIGHT-40)
hopAddon.searchFrame.stringSearching:SetText(HOPADDON_SEARCHPAUSED)
hopAddon.searchFrame.stringSearching:SetShadowColor(0,0,0,1)

hopAddon.searchFrame.stringKeyword = hopAddon.searchFrame:CreateFontString("enterkeywords", "OVERLAY", "GameFontNormal")
hopAddon.searchFrame.stringKeyword:SetPoint("CENTER",0,0)
hopAddon.searchFrame.stringKeyword:SetText(HOPADDON_ENTERKEYWORDS)

hopAddon.searchFrame.Waitdot2 = hopAddon.searchFrame:CreateTexture("Waitdot2","ARTWORK")
hopAddon.searchFrame.Waitdot2:SetPoint("CENTER",0,0)
hopAddon.searchFrame.Waitdot2:SetAtlas("groupfinder-waitdot",true)
hopAddon.searchFrame.Waitdot2:SetVertexColor(1,1,1,0)

hopAddon.searchFrame.Waitdot1 = hopAddon.searchFrame:CreateTexture("Waitdot2","ARTWORK")
hopAddon.searchFrame.Waitdot1:SetPoint("CENTER", "Waitdot2", -16,0)
hopAddon.searchFrame.Waitdot1:SetAtlas("groupfinder-waitdot",true)
hopAddon.searchFrame.Waitdot1:SetVertexColor(1,1,1,0)

hopAddon.searchFrame.Waitdot3 = hopAddon.searchFrame:CreateTexture("Waitdot2","ARTWORK")
hopAddon.searchFrame.Waitdot3:SetPoint("CENTER", "Waitdot2",16,0)
hopAddon.searchFrame.Waitdot3:SetAtlas("groupfinder-waitdot",true)
hopAddon.searchFrame.Waitdot3:SetVertexColor(1,1,1,0)

hopAddon.searchFrame.anim = hopAddon.searchFrame:CreateAnimationGroup("Searching")
hopAddon.searchFrame.anim:SetLooping("REPEAT")

local function AddAlphaAnimation(child,delay,dur,order,from,to)
	local a = hopAddon.searchFrame.anim:CreateAnimation("ALPHA")
	a:SetChildKey(child) 
	a:SetStartDelay(delay)
	a:SetDuration(dur)
	a:SetOrder(order)
	a:SetFromAlpha(from)
	a:SetToAlpha(to)
end

AddAlphaAnimation("Waitdot1",0.50,0.15,1,0,1)
AddAlphaAnimation("Waitdot2",0.50,0.15,2,0,1)
AddAlphaAnimation("Waitdot3",0.50,0.15,3,0,1)
AddAlphaAnimation("Waitdot1",0.50,0.15,4,1,0)
AddAlphaAnimation("Waitdot2",0.50,0.15,4,1,0)
AddAlphaAnimation("Waitdot3",0.50,0.15,4,1,0)

hopAddon.searchFrame.dropDown = CreateFrame("Frame", "CategoryDrop", hopAddon.searchFrame, "UIDropDownMenuTemplate")
hopAddon.searchFrame.dropDown:SetPoint("BOTTOM",0,8)
UIDropDownMenu_SetWidth(hopAddon.searchFrame.dropDown,180)
hopAddon.searchFrame.dropDown.text = hopAddon.searchFrame.dropDown:CreateFontString(nil, "OVERLAY", "GameFontNormal")
hopAddon.searchFrame.dropDown.text:SetSize(136,12)
hopAddon.searchFrame.dropDown.text:SetPoint("RIGHT",hopAddon.searchFrame.dropDown,"RIGHT",-42,3)
hopAddon.searchFrame.dropDown.text:SetJustifyH("RIGHT")

--[[
hopAddon.searchFrame.buttonMinimize = CreateFrame("Button", nil, hopAddon.searchFrame,"UIPanelButtonTemplate")
hopAddon.searchFrame.buttonMinimize:SetSize(20,20)
hopAddon.searchFrame.buttonMinimize:SetPoint("TOPLEFT",hopAddon,25,-6)
hopAddon.searchFrame.buttonMinimize:SetText(" _")
hopAddon.searchFrame.buttonMinimize:SetScript("OnClick", function(btn)
	
end)
]]

hopAddon.searchFrame.searchBox = CreateFrame("EditBox", nil, hopAddon.searchFrame, "SearchBoxTemplate")
hopAddon.searchFrame.searchBox:SetPoint("TOPLEFT", hopAddon, "BOTTOMLEFT", 10, 2)
hopAddon.searchFrame.searchBox:SetAutoFocus(false)
hopAddon.searchFrame.searchBox:EnableMouse(true)
hopAddon.searchFrame.searchBox:SetSize(HOPADDON_WIDTH-34, 24)
hopAddon.searchFrame.searchBox:SetMaxLetters(256)

hopAddon.searchFrame.searchBox.clearButton:SetScript("OnEnter", function(self)
	GameTooltip:SetOwner(self, "ANCHOR_TOP", 0, 0)
	if customSearch then
		GameTooltip:SetText(HOPADDON_STOPSEARCH, 1, 1, 1, true)
	else
		GameTooltip:SetText(HOPADDON_CLEARSEARCH, 1, 1, 1, true)	
	end
	GameTooltip:Show()
end)

hopAddon.searchFrame.searchBox.clearButton:SetScript("OnLeave", function(self)
	GameTooltip:Hide()
end)



-- hop GUI
hopAddon.hopFrame = CreateFrame("Frame",nil,hopAddon)
hopAddon.hopFrame:SetSize(HOPADDON_WIDTH,HOPADDON_HEIGHT)
hopAddon.hopFrame:SetPoint("BOTTOM",0,0)
hopAddon.hopFrame.lastUpdate = 0
hopAddon.hopFrame.queueUpdate = 0

hopAddon.hopFrame.background = hopAddon.hopFrame:CreateTexture(nil,"BORDER")
hopAddon.hopFrame.background:SetSize(HOPADDON_WIDTH+106,HOPADDON_HEIGHT-10)
hopAddon.hopFrame.background:SetPoint("BOTTOM",1,5)
hopAddon.hopFrame.background:SetTexture("Interface\\Challenges\\challenges-besttime-bg")

hopAddon.hopFrame.stringCurRealm = hopAddon.hopFrame:CreateFontString("currentRealm", "OVERLAY", "GameFontNormal")
hopAddon.hopFrame.stringCurRealm:SetPoint("CENTER",0,35)
hopAddon.hopFrame.stringCurRealm:SetText(FRIENDS_LIST_REALM)

hopAddon.hopFrame.stringRealm = hopAddon.hopFrame:CreateFontString("realmname", "OVERLAY", "QuestFont_Shadow_Huge")
hopAddon.hopFrame.stringRealm:SetPoint("CENTER",0,20)
hopAddon.hopFrame.stringRealm:SetTextColor(1, 0.914, 0.682, 1)
hopAddon.hopFrame.stringRealm:SetText(GetRealmName())

hopAddon.hopFrame.hopHelp = hopAddon.hopFrame:CreateFontString("hopHelp", "OVERLAY", "GameFontNormal")
hopAddon.hopFrame.hopHelp:SetPoint("CENTER",0,-10)
hopAddon.hopFrame.hopHelp:SetSize(HOPADDON_WIDTH-12,50)
hopAddon.hopFrame.hopHelp:SetText(HOPADDON_HOPHELP)

hopAddon.hopFrame.buttonHop = CreateFrame("Button",nil,hopAddon.hopFrame,"UIGoldBorderButtonTemplate")
hopAddon.hopFrame.buttonHop:SetSize(100,24)
hopAddon.hopFrame.buttonHop:SetPoint("BOTTOM",55,15)
hopAddon.hopFrame.buttonHop:SetText(HOPADDON_NEXTREALM)

hopAddon.hopFrame.buttonHopBack = CreateFrame("Button",nil,hopAddon.hopFrame,"UIGoldBorderButtonTemplate")
hopAddon.hopFrame.buttonHopBack:SetSize(100,24)
hopAddon.hopFrame.buttonHopBack:SetPoint("BOTTOM",-55,15)
hopAddon.hopFrame.buttonHopBack:SetText(HOPADDON_LASTBUTTON)
hopAddon.hopFrame.buttonHopBack:Disable()
hopAddon.hopFrame.buttonHopBack:SetScript("OnEnter", function(self)
	if lastServer ~= nil then
		GameTooltip:SetOwner(self, "ANCHOR_LEFT")
		GameTooltip:SetText(lastServer)
		GameTooltip:Show()
	end
end)
hopAddon.hopFrame.buttonHopBack:SetScript("OnLeave", function(self)
	GameTooltip:Hide()
end)
hopAddon.hopFrame:Hide()


-- options GUI
hopAddon.optionsFrame = CreateFrame("Frame",nil,hopAddon)
hopAddon.optionsFrame:SetSize(400,295)
hopAddon.optionsFrame:SetPoint("CENTER",UIParent,"CENTER",0,0)
hopAddon.optionsFrame:SetBackdrop({bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background", 
					edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border", 
					tile = true, tileSize = 32, edgeSize = 32, 
					insets = { left = 11, right = 11, top = 12, bottom = 10 }});

hopAddon.optionsFrame:Hide()

hopAddon.optionsFrame.header = hopAddon.optionsFrame:CreateTexture(nil,"ARTWORK")
hopAddon.optionsFrame.header:SetSize(300,68)
hopAddon.optionsFrame.header:SetPoint("TOP",0,12)
hopAddon.optionsFrame.header:SetTexture("Interface\\DialogFrame\\UI-DialogBox-Header")

hopAddon.optionsFrame.headerString = hopAddon.optionsFrame:CreateFontString("headerString", "OVERLAY", "GameFontNormal")
hopAddon.optionsFrame.headerString:SetPoint("TOP",0,-4)
hopAddon.optionsFrame.headerString:SetText("Server Hop v"..SERVERHOP_VERSION)

hopAddon.optionsFrame.closeButton = CreateFrame("Button", nil, hopAddon.optionsFrame,"UIPanelCloseButton")
hopAddon.optionsFrame.closeButton:SetSize(25,25)
hopAddon.optionsFrame.closeButton:SetPoint("TOPRIGHT",-5,-5)
hopAddon.optionsFrame.closeButton:SetScript("OnClick", function(btn)
	hopAddon.optionsFrame:Hide()
end)

-- Author Notes
hopAddon.optionsFrame.optionsAuthor = CreateFrame("Frame",nil,hopAddon.optionsFrame)
local authorFrame = hopAddon.optionsFrame.optionsAuthor
authorFrame:SetBackdrop({ 
					edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", 
					tile = true, tileSize = 16, edgeSize = 16, 
					insets = { left = 5, right = 5, top = 5, bottom = 5 }});
authorFrame:SetSize(360,75)
authorFrame:SetPoint("BOTTOM",0,20)
authorFrame:SetBackdropBorderColor(0.6,0.6,0.6,1)
authorFrame:Show()

authorFrame.updateString = authorFrame:CreateFontString("updateString", "OVERLAY", "GameFontNormal")
authorFrame.updateString:SetWidth(330)
authorFrame.updateString:SetJustifyH("LEFT")
authorFrame.updateString:SetPoint("TOPLEFT",15,-15)
authorFrame.updateString:SetText(HOPADDON_UPDATESTRING)

authorFrame.authorString = authorFrame:CreateFontString("authorString", "OVERLAY", "GameFontNormal")
authorFrame.authorString:SetWidth(330)
authorFrame.authorString:SetJustifyH("LEFT")
authorFrame.authorString:SetPoint("BOTTOMLEFT",15,15)
authorFrame.authorString:SetText(HOPADDON_AUTHOR.."|cFFFFFFFFChronoAS|r")

authorFrame.emailString = authorFrame:CreateFontString("emailstring", "OVERLAY", "GameFontNormal")
authorFrame.emailString:SetWidth(330)
authorFrame.emailString:SetJustifyH("RIGHT")
authorFrame.emailString:SetPoint("BOTTOMLEFT",15,15)
authorFrame.emailString:SetText("E-mail: |cFFFFFFFFchronoexplosion@gmail.com|r")


-- Custom Search options
hopAddon.optionsFrame.customSearchOptionsFrame = CreateFrame("Frame",nil,hopAddon.optionsFrame)
local customOptions = hopAddon.optionsFrame.customSearchOptionsFrame
customOptions:SetBackdrop({ 
					edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", 
					tile = true, tileSize = 16, edgeSize = 16, 
					insets = { left = 5, right = 5, top = 5, bottom = 5 }});

customOptions:SetSize(240,165)
customOptions:SetPoint("TOPRIGHT",-20,-30)
customOptions:SetBackdropBorderColor(0.6,0.6,0.6,1)
customOptions:Show()

-- Apply to group role checkmarks
customOptions.rolesString = customOptions:CreateFontString("rolestring", "OVERLAY", "GameFontNormal")
customOptions.rolesString:SetPoint("TOPLEFT",15,-15)
customOptions.rolesString:SetText(LFG_TOOLTIP_ROLES )

customOptions.tankCheckButton = CreateFrame("CheckButton","CheckBTank",customOptions,"ChatConfigCheckButtonTemplate")
customOptions.tankCheckButton:SetHitRectInsets(0,-60,0,0)
customOptions.tankCheckButton:SetPoint("TOPLEFT",15,-35)
getglobal(customOptions.tankCheckButton:GetName() .. 'Text'):SetText(TANK)
customOptions.tankCheckButton.tooltip = HOPADDON_ROLETOOLTIP
customOptions.tankCheckButton:SetChecked(true)

customOptions.dpsCheckButton = CreateFrame("CheckButton","CheckBDPS",customOptions,"ChatConfigCheckButtonTemplate")
customOptions.dpsCheckButton:SetHitRectInsets(0,-60,0,0)
customOptions.dpsCheckButton:SetPoint("TOPLEFT",15,-55)
getglobal(customOptions.dpsCheckButton:GetName() .. 'Text'):SetText(DAMAGER)
customOptions.dpsCheckButton.tooltip = HOPADDON_ROLETOOLTIP
customOptions.dpsCheckButton:SetChecked(true)

customOptions.healCheckButton = CreateFrame("CheckButton","CheckBHeal",customOptions,"ChatConfigCheckButtonTemplate")
customOptions.healCheckButton:SetHitRectInsets(0,-60,0,0)
customOptions.healCheckButton:SetPoint("TOPLEFT",15,-75)
getglobal(customOptions.healCheckButton:GetName() .. 'Text'):SetText(HEALER)
customOptions.healCheckButton.tooltip = HOPADDON_ROLETOOLTIP
customOptions.healCheckButton:SetChecked(true)

-- Notifications group
customOptions.notifyString = customOptions:CreateFontString("notifystring", "OVERLAY", "GameFontNormal")
customOptions.notifyString:SetPoint("TOPLEFT",100,-15)
customOptions.notifyString:SetText(HOPADDON_NOTIFY)

customOptions.soundCheckButton = CreateFrame("CheckButton","CheckBSound",customOptions,"ChatConfigCheckButtonTemplate")
customOptions.soundCheckButton:SetPoint("TOPLEFT",100,-35)
getglobal(customOptions.soundCheckButton:GetName() .. 'Text'):SetText(ENABLE_SOUND)
customOptions.soundCheckButton.tooltip = HOPADDON_SOUNDTOOLTIP
customOptions.soundCheckButton:SetChecked(true)

-- Search options
customOptions.optionsString = customOptions:CreateFontString("optionsString", "OVERLAY", "GameFontNormal")
customOptions.optionsString:SetPoint("TOPLEFT",15,-110)
customOptions.optionsString:SetText(HOPADDON_SEARCHOPTIONS)

customOptions.endlessCheckBox = CreateFrame("CheckButton","CheckBEndless",customOptions,"ChatConfigCheckButtonTemplate")
customOptions.endlessCheckBox:SetPoint("TOPLEFT",15,-130)
getglobal(customOptions.endlessCheckBox:GetName() .. 'Text'):SetText(HOPADDON_ENDLESSCHECK)
customOptions.endlessCheckBox.tooltip = HOPADDON_ENDLESSTOOLTIP
customOptions.endlessCheckBox:SetChecked(false)


-- Hop Search options
hopAddon.optionsFrame.hopSearchOptionsFrame = CreateFrame("Frame",nil,hopAddon.optionsFrame)
local hopOptions = hopAddon.optionsFrame.hopSearchOptionsFrame
hopOptions:SetBackdrop({ 
					edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", 
					tile = true, tileSize = 16, edgeSize = 16, 
					insets = { left = 5, right = 5, top = 5, bottom = 5 }});

hopOptions:SetSize(240,165)
hopOptions:SetPoint("TOPRIGHT",-20,-30)
hopOptions:SetBackdropBorderColor(0.6,0.6,0.6,1)
hopOptions:Hide()

-- Apply to group role checkmarks
hopOptions.string = hopOptions:CreateFontString("rolestring", "OVERLAY", "GameFontNormal")
hopOptions.string:SetPoint("TOPLEFT",15,-15)
hopOptions.string:SetText(ADVANCED_OPTIONS..":")

hopOptions.autoInviteCheck = CreateFrame("CheckButton","CheckAutoinv",hopOptions,"ChatConfigCheckButtonTemplate")
hopOptions.autoInviteCheck:SetPoint("TOPLEFT",15,-35)
getglobal(hopOptions.autoInviteCheck:GetName() .. 'Text'):SetText(HOPADDON_AUTOINVITE)
hopOptions.autoInviteCheck.tooltip = HOPADDON_AUTOINVITE_TOOLTIP
hopOptions.autoInviteCheck:SetChecked(true)

hopOptions.blacklistString = hopOptions:CreateFontString("rolestring", "OVERLAY", "GameFontNormal")
hopOptions.blacklistString:SetPoint("BOTTOM",0,44)
hopOptions.blacklistString:SetText(HOPADDON_INBLACKLIST.."0")

hopOptions.buttonClearBL = CreateFrame("Button",nil,hopOptions,"UIGoldBorderButtonTemplate")
hopOptions.buttonClearBL:SetSize(140,24)
hopOptions.buttonClearBL:SetPoint("BOTTOM", 0,15)
hopOptions.buttonClearBL:SetText(CLEAR_ALL)
hopOptions.buttonClearBL:SetScript("OnClick", function(btn)
	BlackList = {}
	hopAddon.optionsFrame.hopSearchOptionsFrame.blacklistString:SetText(HOPADDON_INBLACKLIST.."0")
end)



-- Category Bar
hopAddon.optionsFrame.tabList = CreateFrame("Frame",nil,hopAddon.optionsFrame)
local optionTabs = hopAddon.optionsFrame.tabList
optionTabs:SetBackdrop({ 
					edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", 
					tile = true, tileSize = 16, edgeSize = 16, 
					insets = { left = 5, right = 5, top = 5, bottom = 5 }});

optionTabs:SetSize(110,165)
optionTabs:SetPoint("TOPLEFT",20,-30)
optionTabs:Show()

optionTabs.customButton = CreateFrame("Button", nil, optionTabs)
	
local highlightTexture = optionTabs.customButton:CreateTexture()
highlightTexture:SetPoint("TOPLEFT",2,0)
highlightTexture:SetPoint("BOTTOMRIGHT",-2,1)
highlightTexture:SetTexture("Interface\\QuestFrame\\UI-QuestLogTitleHighlight")
optionTabs.customButton:SetHighlightTexture(highlightTexture,"ADD")

optionTabs.customButton.textName = optionTabs.customButton:CreateFontString(nil, "OVERLAY", "GameFontNormal")
optionTabs.customButton.textName:SetSize(156,36)
optionTabs.customButton.textName:SetPoint("LEFT",optionTabs.customButton,"LEFT",8,0)
optionTabs.customButton.textName:SetJustifyH("LEFT")
optionTabs.customButton.textName:SetText(HOPADDON_SEARCHMODE)

optionTabs.customButton:SetSize(110,25)
optionTabs.customButton:SetPoint("TOPLEFT",0,-5)
optionTabs.customButton:SetScript("OnClick", function(btn)
	hopOptions:Hide()
	customOptions:Show()
end)

optionTabs.hopButton = CreateFrame("Button", nil, optionTabs)
	
local highlightTexture = optionTabs.hopButton:CreateTexture()
highlightTexture:SetPoint("TOPLEFT",2,0)
highlightTexture:SetPoint("BOTTOMRIGHT",-2,1)
highlightTexture:SetTexture("Interface\\QuestFrame\\UI-QuestLogTitleHighlight")
optionTabs.hopButton:SetHighlightTexture(highlightTexture,"ADD")

optionTabs.hopButton.textName = optionTabs.hopButton:CreateFontString(nil, "OVERLAY", "GameFontNormal")
optionTabs.hopButton.textName:SetSize(156,36)
optionTabs.hopButton.textName:SetPoint("LEFT",optionTabs.hopButton,"LEFT",8,0)
optionTabs.hopButton.textName:SetJustifyH("LEFT")
optionTabs.hopButton.textName:SetText(HOPADDON_HOPMODE)

optionTabs.hopButton:SetSize(110,25)
optionTabs.hopButton:SetPoint("TOPLEFT",0,-30)
optionTabs.hopButton:SetScript("OnClick", function(btn)
	customOptions:Hide()
	hopOptions:Show()
end)


-- CODE

local function FullScaleSearch(selection, str, filter1, filter2)
	--print("Called search")
	local lang={}
	for k,v in pairs(C_LFGList.GetAvailableLanguageSearchFilter()) do lang[v]=true end
	C_LFGList.ClearSearchResults()
	C_LFGList.Search(selection, str, filter1, filter2, lang)
end

local function UpdateSearchFrames()
	-- update left frames
	for i=1,#CustomSearchList do
		local frame = hopAddon.searchFrame.FrameList[i]
		frame.result = CustomSearchList[i]

		local id, action, caption, desc, voice, ilvl, ctime, bnetfr, charfr, guild, delisted, fullname, pcount, autoinv = C_LFGList.GetSearchResultInfo(frame.result)
		
		-- party name
		frame.textName:SetText(caption)
		
		-- autoinvite text color indication
		if autoinv then
			frame.textName:SetTextColor(0.25,0.75,0.25,1)
		else
			frame.textName:SetTextColor(1,0.82,1,1)
		end
		
		-- party members count
		frame.textCount:SetText(pcount)
		
		-- party members icon
		frame.icon:SetVertexColor(1,1,1,1)				
		if (bnetfr > 0) then
			frame.icon:SetAtlas("groupfinder-icon-friend")		
		elseif (charfr > 0) then
			frame.icon:SetAtlas("groupfinder-icon-friend")		
		elseif (guild > 0 ) then
			frame.icon:SetAtlas("groupfinder-waitdot")
			frame.icon:SetVertexColor(0,1,0,1)	
		else
			frame.icon:SetAtlas("groupfinder-waitdot")
		end
		
		-- frame backdrop
		frame:SetBackdropColor(0,0,0,1)
		frame.icon:Show()
		frame.iconRedx:Hide()
		frame.iconGreenChck:Hide()
		frame.spinner:Hide()
		local id, appStatus, pendingStatus, appDuration = C_LFGList.GetApplicationInfo(frame.result)

		if pendingStatus == "applied" or appStatus == "applied" then
			frame:SetBackdropColor(0.25,0.75,0.25,1)
			frame.icon:Hide()
			frame.spinner:Show()
			frame.spinner.Anim:Play()
		elseif pendingStatus == "invited" or appStatus == "invited" then
			frame:SetBackdropColor(0.25,0.75,0.25,1)
			frame.iconGreenChck:Show()
		elseif appStatus == "invitedeclined" or appStatus == "declined" or appStatus == "timedout" then
			frame.iconRedx:Show()
		end
		
		frame:Show()
	end
	-- hide unused frames
	for i=#CustomSearchList+1,MAX_RESULTS do
		hopAddon.searchFrame.FrameList[i]:Hide()
	end
end


--[[
	DropDown Menu
]]




local function HopSearch()
	HopList = {}
	FullScaleSearch(6,"",0,0)
end

local function CustomSearch()
	CustomSearchList = {}
	hopAddon.searchFrame.stringSearching:SetText(HOPADDON_SEARCHING)
	hopAddon.searchFrame.stringKeyword:Hide()
	hopAddon.searchFrame.anim:Play()
	UpdateSearchFrames()
	FullScaleSearch(hopAddon.searchFrame.dropDown.activeValue,"",0,0)
end

function hopAddon.searchFrame.dropDown_OnClick(self, arg1, arg2, checked)
	local prevValue = hopAddon.searchFrame.dropDown.activeValue
	
	hopAddon.searchFrame.dropDown.activeValue = self.value;
	CloseDropDownMenus();
	hopAddon.searchFrame.dropDown.text:SetText(C_LFGList.GetCategoryInfo(self.value))
	if hopAddon.AddonRequest and prevValue ~= self.value then
		customSearch = true
	end
end


--[[
	End of DropDown Menu
]]


local function RemoveDelisted()
	local i=#CustomSearchList
	while i > 0 do
		local id, action, caption, desc, voice, ilvl, ctime, bnetfr, charfr, guild, delisted, fullname, pcount, autoinv = C_LFGList.GetSearchResultInfo(CustomSearchList[i])
		local id, appStatus, pendingStatus, appDuration = C_LFGList.GetApplicationInfo(CustomSearchList[i])
		
		if delisted or appStatus == "invitedeclined" or appStatus == "declined" or appStatus == "timedout"
		or appStatus == "cancelled" or pendingStatus == "cancelled" or appStatus == "failed" 
		then
			hopAddon.searchFrame.FrameList[i]:Hide()
			--print("Delisted "..caption.." delisted: "..delisted.." "..appStatus.." "..pendingStatus)
			table.remove(CustomSearchList,i)
		end
		i = i - 1
	end
	
	if #CustomSearchList == 0 then customSearch = true end
end

--[[

	Search Field
]]


local function SplitKeywords(keyword)
	SearchKeywords = {}
	for i in string.gmatch(keyword, "%S+") do
		table.insert(SearchKeywords,i)
	end
end



local function FinishHopSearch()
	hopAddon.AddonRequest = false

	hopSearch = false
	
	queue = false
	backSearch = false
	autoAccept = false
	
	hopAddon.hopFrame.lastUpdate = 0
		
	if (lastServer ~= nil) then
		hopAddon.hopFrame.buttonHopBack:Enable()
	end
	hopAddon.hopFrame.buttonHop:SetText(HOPADDON_NEXTREALM)
	hopAddon.hopFrame.buttonHop:Enable()
end

local function FinishCustomSearch()
	hopAddon.AddonRequest = false

	SearchKeywords = {}
	customSearch = false
	CustomSearchList = {}
	CustomSearchBlacklist = {}
	UpdateSearchFrames()
	hopAddon.searchFrame.stringSearching:SetText(HOPADDON_SEARCHPAUSED)	
	hopAddon.searchFrame.stringKeyword:Show()
	hopAddon.searchFrame.anim:Stop()
	hopAddon.searchFrame.lastUpdate = 0	
end


	
--[[
	End of Search Field
]]

--[[
	Search Result Frames
]]

local function ResultFrame_OnEnter(self)
	local resultID = self.result;
	local id, activityID, name, comment, voiceChat, iLvl, age, numBNetFriends, numCharFriends, numGuildMates, isDelisted, leaderName, numMembers, autoinv = C_LFGList.GetSearchResultInfo(resultID);
	local activityName, shortName, categoryID, groupID, minItemLevel, filters, minLevel, maxPlayers, displayType = C_LFGList.GetActivityInfo(activityID);
	local memberCounts = C_LFGList.GetSearchResultMemberCounts(resultID);
	GameTooltip:SetOwner(self, "ANCHOR_RIGHT", 10, -40);
	GameTooltip:SetText(name, 1, 1, 1, true);	
	GameTooltip:AddLine(activityName);
	if autoinv then
		GameTooltip:AddLine(HOPADDON_AUTOINVITE, 0.25, 0.75, 0.25, true)
	end	
	if ( comment ~= "" ) then
		GameTooltip:AddLine(string.format(LFG_LIST_COMMENT_FORMAT, comment), LFG_LIST_COMMENT_FONT_COLOR.r, LFG_LIST_COMMENT_FONT_COLOR.g, LFG_LIST_COMMENT_FONT_COLOR.b, true);
	end
	GameTooltip:AddLine(" ");
	if ( iLvl > 0 ) then
		GameTooltip:AddLine(string.format(LFG_LIST_TOOLTIP_ILVL, iLvl));
	end
	if ( voiceChat ~= "" ) then
		GameTooltip:AddLine(string.format(LFG_LIST_TOOLTIP_VOICE_CHAT, voiceChat), nil, nil, nil, true);
	end
	if ( iLvl > 0 or voiceChat ~= "" ) then
		GameTooltip:AddLine(" ");
	end

	if ( leaderName ) then
		GameTooltip:AddLine(string.format(LFG_LIST_TOOLTIP_LEADER, leaderName));
	end
	if ( age > 0 ) then
		GameTooltip:AddLine(string.format(LFG_LIST_TOOLTIP_AGE, SecondsToTime(age, false, false, 1, false)));
	end

	if ( leaderName or age > 0 ) then
		GameTooltip:AddLine(" ");
	end

	GameTooltip:AddLine(string.format(LFG_LIST_TOOLTIP_MEMBERS, numMembers, memberCounts.TANK, memberCounts.HEALER, memberCounts.DAMAGER));

	if ( numBNetFriends + numCharFriends + numGuildMates > 0 ) then
		GameTooltip:AddLine(" ");
		GameTooltip:AddLine(LFG_LIST_TOOLTIP_FRIENDS_IN_GROUP);
		GameTooltip:AddLine(LFGListSearchEntryUtil_GetFriendList(resultID), 1, 1, 1, true);
	end

	local completedEncounters = C_LFGList.GetSearchResultEncounterInfo(resultID);
	if ( completedEncounters and #completedEncounters > 0 ) then
		GameTooltip:AddLine(" ");
		GameTooltip:AddLine(LFG_LIST_BOSSES_DEFEATED);
		for i=1, #completedEncounters do
			GameTooltip:AddLine(completedEncounters[i], RED_FONT_COLOR.r, RED_FONT_COLOR.g, RED_FONT_COLOR.b);
		end
	end
	
	local id, appStatus, pendingStatus = C_LFGList.GetApplicationInfo(id);

	GameTooltip:AddLine(" ");
	
	if pendingStatus == "applied" or appStatus == "applied" then
		GameTooltip:AddDoubleLine(HOPADDON_CANCELAPP,HOPADDON_RMB,0.75, 0.25, 0);
	elseif pendingStatus == "invited" or appStatus == "invited" then
		GameTooltip:AddDoubleLine(HOPADDON_DECLINEAPP,HOPADDON_RMB,0.75, 0.25, 0);
	else
		GameTooltip:AddDoubleLine(HOPADDON_APPLY,HOPADDON_LMB,0.25, 0.75, 0.25);
		GameTooltip:AddDoubleLine(HOPADDON_BLACKLIST,HOPADDON_RMB,0.75, 0.25, 0);
	end

	GameTooltip:Show();
end

local function MakeResultFrame(index)
	local frame = CreateFrame("Button",nil,hopAddon.searchFrame.searchBox)
	frame:SetSize(208,40)
	if index == 1 then
		frame:SetPoint("TOP", hopAddon.searchFrame.searchBox, "BOTTOM",-5,0)
	else
		frame:SetPoint("TOP", hopAddon.searchFrame.FrameList[index-1], "BOTTOM")	
	end

	frame:SetBackdrop({bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", 
						edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border", 
						tile = true, tileSize = 16, edgeSize = 16, 
						insets = { left = 2, right = 2, top = 2, bottom = 2 }});
	frame:SetBackdropColor(0,0,0,1);
	
	local highlightTexture = frame:CreateTexture()
	highlightTexture:SetPoint("TOPLEFT",-2,5)
	highlightTexture:SetPoint("BOTTOMRIGHT",2,-7)
	highlightTexture:SetTexture("Interface\\PaperDollInfoFrame\\UI-Character-Tab-Highlight")
	frame:SetHighlightTexture(highlightTexture,"ADD")

	frame.icon	= frame:CreateTexture(nil,"OVERLAY")
	frame.icon:SetSize(20,20)
	frame.icon:SetPoint("RIGHT", frame, "RIGHT", -8,0)

	frame.iconRedx	= frame:CreateTexture(nil,"OVERLAY")
	frame.iconRedx:SetSize(20,20)
	frame.iconRedx:SetPoint("RIGHT", frame, "RIGHT", -8,0)
	frame.iconRedx:SetAtlas("groupfinder-icon-redx")

	frame.iconGreenChck	= frame:CreateTexture(nil,"OVERLAY")
	frame.iconGreenChck:SetSize(20,20)
	frame.iconGreenChck:SetPoint("RIGHT", frame, "RIGHT", -8,0)
	frame.iconGreenChck:SetAtlas("Tracker-Check")
	
	frame.spinner = CreateFrame("Frame",nil,frame,"LoadingSpinnerTemplate")
	frame.spinner:SetSize(40,40)
	frame.spinner:SetPoint("RIGHT", frame, "RIGHT", 0,0)
	
	frame.textName = frame:CreateFontString(nil, "OVERLAY", "GameFontNormal")
	frame.textName:SetSize(156,36)
	frame.textName:SetPoint("LEFT",frame,"LEFT",8,0)
	frame.textName:SetJustifyH("LEFT")
	frame.textName:SetText("")

	frame.textCount = frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightSmall")
	frame.textCount:SetSize(17,14)
	frame.textCount:SetPoint("RIGHT",frame.icon,"LEFT",0,0)
	frame.textCount:SetText("")
	
	frame.result = 0
	
	frame:SetScript("OnEnter", ResultFrame_OnEnter)
	frame:SetScript("OnLeave", function(self) GameTooltip:Hide() end);	
	frame:RegisterForClicks("AnyUp")
	frame:SetScript("OnClick", function(self,button,down)
	
		if button == "LeftButton" then
			
			
			local apps = C_LFGList.GetApplications();
			local total = 0
			for i=1, #apps do
				local id, appStatus, pendingStatus,appDuration = C_LFGList.GetApplicationInfo(apps[i]);
				if appDuration == 0 and pendingStatus == "applied" then
					-- phantom groups fix
					-- phantom groups have 0 duration and applied pending
				else
					if pendingStatus == "applied" or appStatus == "applied"
					or pendingStatus == "invited" or appStatus == "invited" then
						total = total + 1
					end
				end
			end
			
			if total < 5 then
				PlaySound("igMainMenuOptionCheckBoxOn")
				local tank, heal, dd = C_LFGList.GetAvailableRoles()
				tank = tank and customOptions.tankCheckButton:GetChecked()
				heal = heal and customOptions.healCheckButton:GetChecked()
				dd = dd and customOptions.dpsCheckButton:GetChecked()
				C_LFGList.ApplyToGroup(self.result, "", tank, heal, dd)

				table.remove(CustomSearchList,index)
				if #CustomSearchList > 0 then
					UpdateSearchFrames()
					if #CustomSearchList >= index then
						ResultFrame_OnEnter(self)
					end
				else
					self:Hide()
					customSearch = true
				end	
			else
				PlaySound("ui_garrison_architecttable_buildingplacementerror")			
			end
		end
		
		if button == "RightButton" then
			local id, action, caption, desc, voice, ilvl, ctime, bnetfr, charfr, guild, delisted, fullname, pcount, autoinv = C_LFGList.GetSearchResultInfo(self.result)
			local id, appStatus, pendingStatus = C_LFGList.GetApplicationInfo(self.result);
			
			if appStatus == "applied" or pendingStatus == "applied" then
				C_LFGList.CancelApplication(self.result)
			elseif pendingStatus == "invited" or appStatus == "invited" then
				LFGListInviteDialog.DeclineButton:Click()
			else
				local t={}
				t[caption]=GetTime()-ctime
				--print("Blacklisted "..caption)
				table.insert(CustomSearchBlacklist,t)
				table.remove(CustomSearchList,index)		
			end
			
			if #CustomSearchList > 0 then
				UpdateSearchFrames()
				if #CustomSearchList >= index then
					ResultFrame_OnEnter(self)
				end
			else
				self:Hide()
				customSearch = true
			end	
			PlaySound("igMainMenuOptionCheckBoxOn")
		end
	end)
	
	frame:Hide()
	hopAddon.searchFrame.FrameList[index]=frame
end

for i=1,MAX_RESULTS do MakeResultFrame(i) end

--[[
	End of Search Result Frames
]]

local function canJoinGroup()
    return (not IsInGroup()) or (UnitIsGroupLeader('player') and not IsInRaid())
end

local function PlayerRealm(fullname)
    fullname = fullname or "???-???"
    local name, realm = strsplit(_G.REALM_SEPARATORS, fullname)
    realm = realm or GetRealmName();
    return realm;
end


local function QueueGroups()

	local apps = C_LFGList.GetApplications()
	for i=1,#apps do
		local id, appStatus, pendingStatus = C_LFGList.GetApplicationInfo(apps[i]);
		
		if appStatus == "applied" or pendingStatus == "applied" then
			C_LFGList.CancelApplication(apps[i])
		elseif pendingStatus == "invited" or appStatus == "invited" then
			LFGListInviteDialog.DeclineButton:Click()
		end
	end

	-- if we're in a group system will create shadow group
	if canJoinGroup() then
		local tank, heal, dd = C_LFGList.GetAvailableRoles()
		
		--print(#HopList.." available. Throwing requests...")
		for k,v in pairs(HopList) do
			if k==6 then break end
			C_LFGList.ApplyToGroup(v, "", tank, heal, dd)
			--print("Applying "..v)
		end
		if #HopList > 5 then
			for i=1,5 do
				table.remove(HopList,1)
			end
		else
			queue = false
			hopSearch = true
		end
	end
end

local function FilterHopSearchGroups()
	hopSearch = false
	HopList = {}
	local count, list = C_LFGList.GetSearchResults()
	if count > MAX_RESULTS then count = MAX_RESULTS end
	--print(count.." groups found.")
	
	if (backSearch) then
		for i = 1,count do
			if list[i]~= nil then
				local id, action, caption, desc, voice, ilvl, time, bnetfr, charfr, guild, delisted, fullname, pcount, autoinv = C_LFGList.GetSearchResultInfo(list[i])
				local realm = PlayerRealm(fullname)
		
				if fullname ~= nil and lastServer == realm then
					table.insert(HopList, id)
				end  
			end
		end			
	else
	-- forward search
		local unfiltered = {}
		
		-- Adding all available groups that don't match blacklist
		for i = 1,count do
			if list[i] ~= nil then
				local id, action, caption, desc, voice, ilvl, time, bnetfr, charfr, guild, delisted, fullname, pcount, autoinv = C_LFGList.GetSearchResultInfo(list[i])
				local realm = PlayerRealm(fullname)

				if fullname ~= nil
				and (BlackList[realm] == nil or (GetTime()-BlackList[realm] > blacklistLength)) then
					if not hopAddon.optionsFrame.hopSearchOptionsFrame.autoInviteCheck:GetChecked() then
						-- if putting all groups filter autoivite on top
						unfiltered[id] = autoinv
					elseif autoinv then
						-- if putting only autoinvite then don't need to sort
						table.insert(HopList,id)
					end
				end		
			end
		end

		if not hopAddon.optionsFrame.hopSearchOptionsFrame.autoInviteCheck:GetChecked() then
			-- checking unfiltered for autoinvite, putting them on top first
			for id,auto in pairs(unfiltered) do
				if auto then table.insert(HopList,id) end
			end
			-- then putting simple invites
			for id,auto in pairs(unfiltered) do
				if not auto then table.insert(HopList,id) end
			end
		end

	end
	
	hopAddon.hopFrame.queueUpdate = QUEUE_INTERVAL
	queue = true
	
end

local function FilterCustomSearchGroups()
	customSearch = false
	CustomSearchList = {}
	local count, list = C_LFGList.GetSearchResults()
	if count > MAX_RESULTS then count = MAX_RESULTS end
	
	for i = 1,count do
		if list[i] ~= nil then
			local id, action, caption, desc, voice, ilvl, ctime, bnetfr, charfr, guild, delisted, fullname, pcount, autoinv = C_LFGList.GetSearchResultInfo(list[i])
			-- check for blacklist
			local bl = false
			local epsilon = 2 
			for k,v in pairs(CustomSearchBlacklist) do
				for key,value in pairs(v) do
					if key == caption then
						if (value <= GetTime()-ctime+epsilon) and (value >= GetTime()-ctime-epsilon) then
							--print("Blacklist match: "..key.." "..value)
							bl = true
						end
					end				
				end
				if bl then break end
			end
			-- if not blacklisted check for keywords
			if not bl and #SearchKeywords > 0 then
				-- use action name in quests, dungeons and raids
				local actionName = ""
				if hopAddon.searchFrame.dropDown.activeValue == 1 
				or hopAddon.searchFrame.dropDown.activeValue == 2 
				or hopAddon.searchFrame.dropDown.activeValue == 3 then
					actionName = C_LFGList.GetActivityInfo(action)
				end
				
				local app = actionName:lower().." "..caption:lower().." "..desc:lower();
				for k,word in pairs(SearchKeywords) do
					if app:find(word) then
						table.insert(CustomSearchList,id)
						break
					end
				end
			end
		end
	end
	if #CustomSearchList > 0 then
		hopAddon.searchFrame.stringSearching:SetText(HOPADDON_SEARCHPAUSED)
		hopAddon.searchFrame.anim:Stop()
		UpdateSearchFrames()
		if customOptions.soundCheckButton:GetChecked() then
			PlaySound("UI_GroupFinderReceiveApplication","Master")
		end
	else
		if hopAddon.AddonRequest then
			customSearch = true
		end
	end
end

local function ServerHop_Update(self,elapsed)
	if hopAddon.AddonRequest then
	
		hopAddon.hopFrame.lastUpdate = hopAddon.hopFrame.lastUpdate + elapsed
		hopAddon.hopFrame.queueUpdate = hopAddon.hopFrame.queueUpdate + elapsed
		hopAddon.searchFrame.lastUpdate = hopAddon.searchFrame.lastUpdate + elapsed
		
		-- HARDTESTED: blizzard allows to throw 2 search results per 5 seconds
		-- results you get from pressing refresh button faster ARE FAKE D:
		-- for hopSearch we should get(update - blizzard gives only 100 results) results as soon as possible
		if (hopSearch and hopAddon.hopFrame.lastUpdate > 0.5) then
		
			HopSearch()
		
			hopAddon.hopFrame.lastUpdate = 0
		end
		
		-- Queuing for groups made found with hop search
		if (queue and hopAddon.hopFrame.queueUpdate > QUEUE_INTERVAL) then
		
			QueueGroups()
		
			hopAddon.hopFrame.queueUpdate = 0
		end
		
		-- for customSearch we just get results when they should be available
		if (customSearch and hopAddon.searchFrame.lastUpdate > 2.5) then
				
			CustomSearch()

			hopAddon.searchFrame.lastUpdate = 0
		end
	
	end
end

local function ServerHop_EventSystem(self, event, ...)
	local arg1 = ...
	if event == "PLAYER_LOGIN" then	
		if ServerHopPosition == nil then
			ServerHopPosition = {}
			ServerHopPosition[1]="CENTER"
			ServerHopPosition[2]=0
			ServerHopPosition[3]=0
			ServerHopPosition[4]=hopAddon:IsShown()
		else
			hopAddon:SetPoint(ServerHopPosition[1],ServerHopPosition[2],ServerHopPosition[3])
			if ServerHopPosition[4] then
				hopAddon:Show()
			end
		end
				
		hopAddon.searchFrame.dropDown.activeValue = 6
		hopAddon.searchFrame.dropDown.text:SetText(C_LFGList.GetCategoryInfo(hopAddon.searchFrame.dropDown.activeValue))

		if ServerHopSettings == nil then
			ServerHopSettings = {}
			ServerHopSettings[1] = true
			ServerHopSettings[2] = true
			ServerHopSettings[3] = true
			ServerHopSettings[4] = true
			ServerHopSettings[5] = false
			-- Only Auto Invite
			ServerHopSettings[6] = true
		else
			customOptions.tankCheckButton:SetChecked(ServerHopSettings[1])
			customOptions.dpsCheckButton:SetChecked(ServerHopSettings[2])
			customOptions.healCheckButton:SetChecked(ServerHopSettings[3])
			customOptions.soundCheckButton:SetChecked(ServerHopSettings[4])
			customOptions.endlessCheckBox:SetChecked(ServerHopSettings[5])
			hopAddon.optionsFrame.hopSearchOptionsFrame.autoInviteCheck:SetChecked(ServerHopSettings[6])
		end
		
	elseif event == "PLAYER_LOGOUT" then
	
		local point, relativeTo, relativePoint, xOfs, yOfs = hopAddon:GetPoint()
		
		ServerHopPosition[1]=point
		ServerHopPosition[2]=xOfs
		ServerHopPosition[3]=yOfs
		ServerHopPosition[4]=hopAddon:IsShown()
		
		ServerHopSettings[1] = customOptions.tankCheckButton:GetChecked()
		ServerHopSettings[2] = customOptions.dpsCheckButton:GetChecked()
		ServerHopSettings[3] = customOptions.healCheckButton:GetChecked()
		ServerHopSettings[4] = customOptions.soundCheckButton:GetChecked()
		ServerHopSettings[5] = customOptions.endlessCheckBox:GetChecked()
		ServerHopSettings[6] = hopAddon.optionsFrame.hopSearchOptionsFrame.autoInviteCheck:GetChecked()
	end
	
	if event == "LFG_LIST_SEARCH_RESULTS_RECEIVED" then
		if hopAddon.AddonRequest then
			if hopSearch then
				FilterHopSearchGroups()
			end
		end
			FilterCustomSearchGroups()
	end
	if event == "LFG_LIST_SEARCH_RESULT_UPDATED" then
		if autoAccept then
			local apps = C_LFGList.GetApplications();
			for i=1, #apps do
				local id, status, pendingStatus = C_LFGList.GetApplicationInfo(apps[i]);
				if status == "invited" and not pendingStatus then
					LFGListInviteDialog.AcceptButton:Click()
					--print("Joining "..apps[i])
					break
				end
			end
		end
		if #CustomSearchList > 0 then
			RemoveDelisted()
			UpdateSearchFrames()
		end
	end
	if event == "LFG_LIST_SEARCH_FAILED" then
		
		-- old method used this
		
	end
	if event == "GROUP_ROSTER_UPDATE" then
		if canJoinGroup() then
			if autoAccept and not hopSearch then
				HopSearch()
			end
			if not autoAccept then
				firstTime = true
			end
			hopAddon.hopFrame.stringRealm:SetText(GetRealmName())
		else
			-- Checking Server Name
			local index = GetNumGroupMembers()
			local name, server
			if IsInRaid() then
				for i=1,index do
					if UnitIsGroupLeader("raid"..i) then
						name,server = UnitName("raid"..i)
						server = server or GetRealmName()
					end
				end
			else
				for i=1,5 do
					if UnitIsGroupLeader("party"..i) then
						name,server = UnitName("party"..i)
						server = server or GetRealmName()
					end
				end
			end
			hopAddon.hopFrame.stringRealm:SetText(server)
			
			-- Closing Searches
			if hopAddon.AddonRequest then
				FinishHopSearch()
				if customOptions.endlessCheckBox:GetChecked() then
					FinishCustomSearch()
				end
			end	
		end
	end
	if event == "LFG_LIST_JOINED_GROUP" then
		--print("Joined")
		local id, action, caption, desc, voice, ilvl, time, bnetfr, charfr, guild, delisted, fullname, pcount, autoinv = C_LFGList.GetSearchResultInfo(arg1)
		
		local apps = C_LFGList.GetApplications();

		for i=1, #apps-1 do
			LFGListInviteDialog.AcknowledgeButton:Click()
		end
	end
end

function ButtonPress()
	hopAddon.hopFrame.buttonHop:Disable()
	hopAddon.hopFrame.buttonHopBack:Disable()
	hopAddon.hopFrame.buttonHop:SetText(HOPADDON_HOPPING)
	
	local index = GetNumGroupMembers()
	local name, server
	
	if IsInRaid() then
		for i=1,index do
			if UnitIsGroupLeader("raid"..i) then
				name,server = UnitName("raid"..i)
				server = server or GetRealmName()
				BlackList[server]=GetTime()
			end
		end
	else
		for i=1,5 do
			if UnitIsGroupLeader("party"..i) then
				name,server = UnitName("party"..i)
				server = server or GetRealmName()
				BlackList[server]=GetTime()
			end
		end
	end
	--print(server)
	lastServer = server

	local blackCount = 0
	for k,v in pairs(BlackList) do
		blackCount = blackCount + 1
	end
	hopAddon.optionsFrame.hopSearchOptionsFrame.blacklistString:SetText(HOPADDON_INBLACKLIST..""..blackCount)

	
	autoAccept = true
	backSearch = false
	
	LeaveParty()
	
	hopAddon.AddonRequest = true
	
	HopList = {}
	hopSearch = true
end

function ButtonBackPress()
	hopAddon.hopFrame.buttonHop:Disable()
	hopAddon.hopFrame.buttonHopBack:Disable()
	hopAddon.hopFrame.buttonHop:SetText(HOPADDON_HOPPING)


	LeaveParty()
	--[[if (lastServer ~= nil) then
		if (firstTime) then
			HopSearch()
			firstTime = false
		end
	end
	]]
	hopAddon.AddonRequest = true
	autoAccept = true
	backSearch = true

	hopSearch = true
end

--Events
hopAddon:SetScript("OnEvent", ServerHop_EventSystem)
hopAddon:RegisterEvent("PLAYER_LOGIN")
hopAddon:RegisterEvent("PLAYER_LOGOUT")
hopAddon:RegisterEvent("LFG_LIST_SEARCH_RESULT_UPDATED")
hopAddon:RegisterEvent("LFG_LIST_SEARCH_FAILED")
hopAddon:RegisterEvent("LFG_LIST_SEARCH_RESULTS_RECEIVED")
hopAddon:RegisterEvent("LFG_LIST_JOINED_GROUP")
hopAddon:RegisterEvent("GROUP_ROSTER_UPDATE")
--Update
hopAddon:SetScript("OnUpdate", ServerHop_Update)
--Dragging
hopAddon:SetMovable(true)
hopAddon:EnableMouse(true)
hopAddon:RegisterForDrag("LeftButton")
hopAddon:SetScript("OnDragStart", hopAddon.StartMoving)
hopAddon:SetScript("OnDragStop", hopAddon.StopMovingOrSizing)

-- hop forward button
hopAddon.hopFrame.buttonHop:SetScript("OnClick", function(btn)

	ButtonPress()

end)

hopAddon.hopFrame.buttonHopBack:SetScript("OnClick", function(btn)

	ButtonBackPress()

end)

-- custom search dropdown init
local CategoryList = {}

hopAddon.searchFrame.dropDown.initialize = function(self, level)

    if not level then return end
    wipe(CategoryList)
    if level == 1 then
		local categories = C_LFGList.GetAvailableCategories();
		for i=1, #categories do
			local categoryID = categories[i];
			local name, separateRecommended, autoChoose, preferCurrentArea = C_LFGList.GetCategoryInfo(categoryID);

			CategoryList.text = name;
			CategoryList.value = categoryID;
			CategoryList.func = hopAddon.searchFrame.dropDown_OnClick;
			CategoryList.checked = self.activeValue == CategoryList.value;
			UIDropDownMenu_AddButton(CategoryList, 1);
		end
	end
	
end


hopAddon.searchFrame.searchBox:SetScript("OnEditFocusGained", function(frame)
	hopAddon.searchFrame.SearchString = frame:GetText()
end)
hopAddon.searchFrame.searchBox:SetScript("OnEscapePressed", function(frame)
	frame:ClearFocus()
	frame:SetText(hopAddon.searchFrame.SearchString)
end)

function hopAddon_searchBox_OnEnter(frame)
	hopAddon.AddonRequest = true
	
	frame:ClearFocus()
	SplitKeywords(frame:GetText():lower())
	CustomSearchList = {}
	hopAddon.searchFrame.lastUpdate = 2.5

	if #SearchKeywords > 0 then
		customSearch = true
	end
end

hopAddon.searchFrame.searchBox:SetScript("OnEnterPressed", hopAddon_searchBox_OnEnter)

hopAddon.searchFrame.searchBox.clearButton:SetScript("OnClick", function(btn)
	if customSearch then
		-- just pause search
		FinishCustomSearch()
		GameTooltip:SetText(HOPADDON_CLEARSEARCH,1,1,1,true)
	else
		-- also clear field
		SearchBoxTemplateClearButton_OnClick(btn)
		hopAddon.searchFrame.SearchString = ""
		FinishCustomSearch()
	end
end)

-- options frame toggle button
hopAddon.buttonOptions:SetScript("OnClick", function(button)
	if not hopAddon.optionsFrame:IsShown() then
		hopAddon.optionsFrame:Show()
	else
		hopAddon.optionsFrame:Hide()	
	end
end)

-- hop/search mode toggle button
hopAddon.buttonChangeMode:SetScript("OnClick", function(btn)
	FinishHopSearch()
	FinishCustomSearch()

	if hopAddon.hopFrame:IsShown() then
		hopAddon.hopFrame:Hide()
		hopAddon.searchFrame:Show()
	else
		hopAddon.hopFrame:Show()
		hopAddon.searchFrame:Hide()
	end

end)


-- addon toggle button
local toggleButton = CreateFrame("Button",nil,LFGListFrame,"UIPanelButtonTemplate")
toggleButton:SetSize(70,22)
toggleButton:SetPoint("BOTTOM",LFGListFrame,"BOTTOM",-4,5)
toggleButton:SetText(" ServerHop")
toggleButton:SetScript("OnClick", function(btn)
	if hopAddon:IsShown() then
		hopAddon:Hide()
	else
		hopAddon:Show()
	end
end)

toggleButton:SetScript("OnEnter", function(self)
	GameTooltip:SetOwner(self, "ANCHOR_RIGHT")
	GameTooltip:SetText(HOPADDON_TOGGLE)
	GameTooltip:Show()
end)
toggleButton:SetScript("OnLeave", function(self) GameTooltip:Hide() end)
